
/*************************************************************************************************
This file is part of CelsiusAFahrenheit

Copyright (C) 2009 Ezequiel Gastn Miravalles

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*************************************************************************************************/

/*************************************************************************************************
Software: CelsiusAFahrenheit
Author: Ezequiel Gastn Miravalles
Website: http://www.neoegm.com/es/tech/programming/c-cpp/wxwidgets/celsius-to-fahrenheit/
License: GNU GPL v3 (attached, read above)
*************************************************************************************************/

//---------------------------------------------------------------------------
//
// Name:        CelsiusAFahrenheitDlg.cpp
// Author:      Owner
// Created:     6/30/2009 7:46:59 PM
// Description: CelsiusAFahrenheitDlg class implementation
//
//---------------------------------------------------------------------------

#include "CelsiusAFahrenheitDlg.h"

//Do not add custom headers
//wxDev-C++ designer will remove them
////Header Include Start
////Header Include End

//----------------------------------------------------------------------------
// CelsiusAFahrenheitDlg
//----------------------------------------------------------------------------
//Add Custom Events only in the appropriate block.
//Code added in other places will be removed by wxDev-C++
////Event Table Start
BEGIN_EVENT_TABLE(CelsiusAFahrenheitDlg,wxDialog)
	////Manual Code Start
	////Manual Code End
	
	EVT_CLOSE(CelsiusAFahrenheitDlg::OnClose)
	EVT_BUTTON(ID_WXBUTTON3,CelsiusAFahrenheitDlg::WxButton3Click)
	EVT_BUTTON(ID_WXBUTTON2,CelsiusAFahrenheitDlg::WxButton2Click)
	EVT_BUTTON(ID_WXBUTTON1,CelsiusAFahrenheitDlg::WxButton1Click)
END_EVENT_TABLE()
////Event Table End

CelsiusAFahrenheitDlg::CelsiusAFahrenheitDlg(wxWindow *parent, wxWindowID id, const wxString &title, const wxPoint &position, const wxSize& size, long style)
: wxDialog(parent, id, title, position, size, style)
{
	CreateGUIControls();
}

CelsiusAFahrenheitDlg::~CelsiusAFahrenheitDlg()
{
} 

void CelsiusAFahrenheitDlg::CreateGUIControls()
{
	//Do not add custom code between
	//GUI Items Creation Start and GUI Items Creation End.
	//wxDev-C++ designer will remove them.
	//Add the custom code before or after the blocks
	////GUI Items Creation Start

	SetTitle(wxT("Celsius a Fahrenheit"));
	SetIcon(wxNullIcon);
	SetSize(8,8,356,211);
	Center();
	

	WxButton3 = new wxButton(this, ID_WXBUTTON3, wxT("A C"), wxPoint(256,56), wxSize(83,33), 0, wxDefaultValidator, wxT("WxButton3"));
	WxButton3->SetFont(wxFont(20, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxButton2 = new wxButton(this, ID_WXBUTTON2, wxT("A F"), wxPoint(256,16), wxSize(83,33), 0, wxDefaultValidator, wxT("WxButton2"));
	WxButton2->SetFont(wxFont(20, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxStaticText2 = new wxStaticText(this, ID_WXSTATICTEXT2, wxT("F"), wxPoint(8,56), wxDefaultSize, 0, wxT("WxStaticText2"));
	WxStaticText2->SetFont(wxFont(20, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxStaticText1 = new wxStaticText(this, ID_WXSTATICTEXT1, wxT("C"), wxPoint(8,16), wxDefaultSize, 0, wxT("WxStaticText1"));
	WxStaticText1->SetFont(wxFont(20, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxF = new wxTextCtrl(this, ID_WXF, wxT(""), wxPoint(55,55), wxSize(193,33), 0, wxDefaultValidator, wxT("WxF"));
	WxF->SetFont(wxFont(20, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxC = new wxTextCtrl(this, ID_WXC, wxT(""), wxPoint(55,16), wxSize(193,35), 0, wxDefaultValidator, wxT("WxC"));
	WxC->SetFont(wxFont(20, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxButton1 = new wxButton(this, ID_WXBUTTON1, wxT("Cerrar"), wxPoint(95,101), wxSize(179,66), 0, wxDefaultValidator, wxT("WxButton1"));
	WxButton1->SetFont(wxFont(20, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	////GUI Items Creation End
}

void CelsiusAFahrenheitDlg::OnClose(wxCloseEvent& /*event*/)
{
	Destroy();
}

/*
 * WxButton1Click
 */
void CelsiusAFahrenheitDlg::WxButton1Click(wxCommandEvent& event)
{
	if (wxMessageBox("Esta seguro de que desea\ncerrar la aplicacion?", "Salir", wxYES_NO | wxICON_QUESTION) == wxYES)
		Destroy();
}

/*
 * WxButton2Click
 */
void CelsiusAFahrenheitDlg::WxButton2Click(wxCommandEvent& event)
{
	double a;
	
	if(WxC->GetValue().ToDouble(&a))
	{
		//wxString c;
		//c = c.Format("%ld", a);
		
		//WxF->SetValue(c);
		
		
		WxF->SetValue(wxString::Format("%.2lf", (9.0/5)*a+32));
	}
	else
		wxMessageBox("Error", "Conversion", wxOK | wxICON_EXCLAMATION);
}

/*
 * WxButton3Click
 */
void CelsiusAFahrenheitDlg::WxButton3Click(wxCommandEvent& event)
{
	double a;
	if (WxF->GetValue().ToDouble(&a))
	{

		//wxString c;
		//c = c.Format("%ld", a);

		//WxF->SetValue(c);


		WxC->SetValue(wxString::Format("%.2lf", (5.0/9)*(a-32)));
	}
	else
		wxMessageBox("Error", "Conversion", wxOK | wxICON_EXCLAMATION);
}
